/* 
    ViewWin Widget for Bt848 frame grabber driver

    Copyright (C) 1996,97 Marcus Metzler (mocm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* 
 * ViewWinP.h - Private definitions for ViewWin widget
 */

#ifndef _ViewWinP_h
#define _ViewWinP_h

/*
 * Include public header file for this widget.
 */
#include "ViewWin.h"


/* New fields for the ViewWin widget class record */

typedef struct {
	int make_compiler_happy;	/* keep compiler happy */
} ViewWinClassPart;



/* Full class record declaration */
typedef struct _ViewWinClassRec {
    CoreClassPart	core_class;
    ViewWinClassPart	viewwin_class;
} ViewWinClassRec;

extern ViewWinClassRec viewwinClassRec;


/* New fields for the ViewWin widget record */
typedef struct {
  /* resources */
  char *visname;
  /* private state */
  Visual *visual;
  XColor colors[256];
} ViewWinPart;

/*
 * Full instance record declaration
 */
typedef struct _ViewWinRec {
    CorePart		    core;
    ViewWinPart	    ViewWin;
} ViewWinRec;

#endif /* _ViewWinP_h */

