/* 
    glide - display picture on a 3dfx card 
            (3dfx card and glide library required)

    Copyright (C) 1997 Ralph Metzler (rjkm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include <assert.h>
#include <unistd.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
// #include <glide.h>
#include "bttv.h"
#include "bt848.h"

//GrHwConfiguration hwconfig;
struct bttv_window wtw;

int fbttv;
char *bttvname="/dev/bttv";

/* set this to 640 x 480 for NTSC */

#define _width_ 320
#define _height_ 240
#define _bpp_ 1

unsigned char Mem[_width_ * _height_ * _bpp_];

void main( int argc, char **argv) {
  
  if ((fbttv=open(bttvname,O_RDWR)) < 0) {
    printf("Cannot open %s\n", bttvname);
    exit(1);
  }
  
  ioctl(fbttv, BTTV_GETWTW, &wtw);
  wtw.y = 0;
  wtw.x = 0;
  wtw.bpp = _bpp_;
  wtw.width = _width_;
  wtw.height = _height_;
  wtw.swidth = _width_;
  wtw.sheight = _height_;
  wtw.bpl = (_width_ * _bpp_);
  wtw.norm = 0;
  wtw.interlace = 1;



  for (int i=0; i<4; i++)
    {
  int dat = i;
  ioctl(fbttv, BTTV_INPUT, &dat);
  ioctl(fbttv, BTTV_SETWTW, &wtw);
  ioctl(fbttv, BTTV_CAP_ON,0);
//  ioctl(fbttv, BTTV_SETVIRTADR, &Mem);
//  ioctl(fbttv, BTTV_SETCLIP, 0);
 
  ioctl(fbttv, BTTV_TESTM, &Mem[0]);

/*
  ioctl(fbttv, BTTV_CAP_ON,0);
  
  scanf("%d");

  ioctl(fbttv, BTTV_CAP_OFF,0);
*/
//  int rd = read(fbttv,&Mem[0],sizeof(Mem));

//  printf("%d bytes read\n");
  
  char st[256];
  
  sprintf(st,"grap%d.raw",i);

  int fd = open(st,O_CREAT|O_TRUNC|O_RDWR,0644);
  int wr = write(fd,&Mem[0],sizeof(Mem));
  printf("%d bytes written\n");
  close(fd);
  ioctl(fbttv, BTTV_CAP_OFF,0);
  }

}

