


#include "grabber.h"
#include <sys/mman.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <stdlib.h>


#include "utils.h"

/*
#include "bttv.h"
#include <fstream.h>



#include <forms.h>
#include "xcap.h"
#include "capture.h"
*/

/*
t_sizemode SizeMode[] = {
                         {"160x120" , 1,160,120,1},
                         {"192x144" , 2,192,144,0},
                         {"240x180" , 3,240,180,1},
//                         {"288x216" , 4,288,216,0}, 
                         {"320x240" , 4,320,240,1},
                         {"360x288" , 5,360,288,0},
                         {"384x288" , 6,384,288,0},
//                         {"576x432" , 7,576,432,0}, 
                         {"640x480" , 8,640,480,1},
                         {"768x576" , 9,768,576,0},
                         {"16x9"    ,10,320,180,0}, 
                	 {"set mode", 0,768,576,0}
                        };
                         
#define VN(a) {a,#a}

Gmode gmode[] =
{
  VN(StaticGray), VN(GrayScale), VN(StaticColor),
  VN(PseudoColor), VN(TrueColor), VN(DirectColor),
};

*/


XImage *x_img;
bttv_window wtw;   
int tv_fd;
int vid_source;


#ifdef DEBUG
#define CHECK_POINT(x,y)	fprintf(stderr,"%s: p%d\n",x,y)
#else
#define CHECK_POINT(x,y)	
#endif


void bttv_close(void)
{
   CHECK_POINT("bttv_close",1);

   int err = ioctl(tv_fd,BTTV_UNLOCK_XIMG,0); 
   if (err != 0)
      {
       fprintf(stderr,"unlock ximage error %d\n",err);
      } 

   if (tv_fd > 0)
      close(tv_fd);
      
   tv_fd = -1;   
}



void bttv_open(void)// int bpp_mode,int WIDTH,int HEIGHT,int pal)
{
   if (tv_fd > 0)
      bttv_close();

//   CHECK_POINT("xcap_open",1);   
//   fl_show_form(fd_xcap->xcap,FL_PLACE_CENTER,FL_TRANSIENT,"xcap");

//   CHECK_POINT("xcap_open",2);   
//   fl_winresize(fl_get_canvas_id(fd_xcap->canvas),WIDTH,HEIGHT);   

//   CHECK_POINT("xcap_open",3);   
//   fl_winresize(fd_xcap->xcap->window,WIDTH+10,HEIGHT+10);   

//   win = fl_get_canvas_id(fd_xcap->canvas);
//   canvasGC = fl_state[fl_get_form_vclass(fd_xcap->xcap)].gc[0];

   CHECK_POINT("xcap_open",4);   
   tv_fd = open(BTTV_DEV,O_RDWR | O_EXCL | O_NDELAY);
   if (tv_fd <= 0) 
      {
       fprintf(stderr,"could not open device %s\n",BTTV_DEV);
       exit(1);
      }
      
   CHECK_POINT("xcap_open",5);   
   ioctl(tv_fd, BTTV_GETWTW, &wtw);
   wtw.x = 0;
   wtw.y = 0;
   wtw.bpp = BPP;
   wtw.width = WIDTH;
   wtw.height = HEIGHT;
   wtw.cropwidth = WIDTH;
   wtw.cropheight = HEIGHT;
   wtw.cropx = 0;
   wtw.cropy = 0;
   wtw.swidth = WIDTH;
   wtw.sheight = HEIGHT;
   wtw.bpl = (WIDTH * wtw.bpp);
//   vid_norm = pal;
   wtw.norm = 1;   // NTSC
   
   if (WIDTH > 639)
      wtw.interlace = 1;
    else  
      wtw.interlace = 0;
      
//   wtw.color_fmt = 0x11;
   ioctl(tv_fd, BTTV_SETWTW, &wtw);

   vid_source = 1;   // composite video input
   ioctl(tv_fd, BTTV_INPUT, &vid_source);

   x_img->width = WIDTH;
   x_img->height = HEIGHT;
   x_img->depth = 8 * BPP;
   x_img->bytes_per_line = WIDTH * BPP;
   x_img->bits_per_pixel = 8 * BPP;

  CHECK_POINT("xcap_open",6);   
//  if (XInitImage(x_img) == 0)
//     {
//      fprintf(stderr,"XInitImage: error\n");
//      bttv_close();
//      exit(2);
//     }

  CHECK_POINT("xcap_open",7);   
  int err = ioctl(tv_fd,BTTV_LOCK_XIMG,x_img); 
  if (err != 0)
     {
      fprintf(stderr,"could not announce ximage memory @ 0x%lx to driver (error %d)\n",(unsigned long)x_img,err);
      bttv_close();
      exit(3);
     }
}


void grabber_init(void)
{
   CHECK_POINT("xcap_init",1);

//   vid_buffer = &picture[0];   
//   disp = FL_FormDisplay(fd_xcap->xcap);

   tv_fd = -1;
//   dont_map_image = true;
//   Size = 1;

//   pic_num = 1;
//   seconds = 1;

   x_img = (XImage *)malloc(sizeof(XImage));
   x_img->xoffset = 0;
   x_img->format = ZPixmap;
   x_img->data = (char *)malloc(BTTV_LOCKMEMSIZE);
   x_img->byte_order = LSBFirst;
   x_img->bitmap_unit = 32; 
   x_img->bitmap_bit_order = LSBFirst;
   x_img->bitmap_pad = 32;

   if (mlock(x_img->data, BTTV_LOCKMEMSIZE))
      {
       // fprintf(stderr,"mlock failed\n");   
       ErrorMsg("mlock failed",errno);
       exit(3);
      } 

   /* swap the memory in */
   for (int i=0; i<BTTV_LOCKMEMSIZE; i += 4096)
      x_img->data[i] = 1;
 
   x_img->data[BTTV_LOCKMEMSIZE -1] = 1;
   
//   xcap_open(SizeMode[Size].width,SizeMode[Size].height);
//   return GetModeInfo();
}


void init_picture(void)
{
#ifdef NO_CARD
   srandom(1001);
#else
   grabber_init(); 
   bttv_open();
   ioctl(tv_fd,BTTV_FILL_XIMG,0); 
#endif //NO_CARD   
}

void done_picture(void)
{
#ifndef NO_CARD
   CHECK_POINT("xcap_exit",1);

   bttv_close();
   
   munlock(x_img->data,BTTV_LOCKMEMSIZE);
   free(x_img->data);
   
//   exit(0);
#endif   
}


void SetCtrl(long c,int j)
{
   if (tv_fd < 0)
      return;   

   int k;   
   int i = j;
   
   switch(c)
     {
      case CMD_BRITE:    ioctl(tv_fd,BTTV_BRIGHT,&i); 	break;
      case CMD_HUE:      ioctl(tv_fd,BTTV_HUE,&i);    	break;
      case CMD_COLOR:    ioctl(tv_fd,BTTV_COLOR,&i);  	break;
      case CMD_CONTRAST: ioctl(tv_fd,BTTV_CONTRAST,&i);	break;        
        
      case CMD_SOURCE: 
        i = j % 4;
        ioctl(tv_fd, BTTV_INPUT, &i);
        break;

      case CMD_FREQUENCY: 
        k = 0;
        ioctl(tv_fd, BTTV_SETFREQ,&i);
        ioctl(tv_fd, BTTV_INPUT, &k);

        k = 1;
        ioctl(tv_fd, BTTV_MUTE,&k);
        break;
     }
}




int error_cap = 0;

char Do_Capture(void)
{
   if (tv_fd < 0) 
      return false;

   int err;

   if (ioctl(tv_fd,BTTV_XIMG_READY,0) == 0)
      {
       if (error_cap > 3)
          err = ioctl(tv_fd,BTTV_FILL_XIMG,0); 
      
       if (error_cap > 8)
          {
           bttv_close();
           bttv_open();
           error_cap = 0;
          } 
           
//       idle_cnt++;        
       error_cap++;    
#ifdef DEBUG
//       fprintf(stderr,"error_cap %d\n",error_cap); 
#endif              
       return false;
      } 
   
   error_cap = 0;

   for (int i=0; i<PIC_SIZE; i++)
     picture[i] = x_img->data[i];

   err = ioctl(tv_fd,BTTV_FILL_XIMG,0); 
   if (err != 0)
      {
       fprintf(stderr,"could not grab error %d\n",err);
       return true; 
      } 

   return true;
}







void read_picture(void)
{
#ifdef DEBUG
//   fprintf(stderr,"reading picture\n");
#endif   

#ifdef NO_CARD
//   for (int i=0; i<PIC_SIZE; i++)
//      picture[i] = (char)(((double)random()*255.0)/(double)(RAND_MAX+1));
  
   for (int j=0; j<HEIGHT; j++)
     for (int i=0; i<WIDTH; i++)
       {
        unsigned short *pix = (unsigned short *)&picture[(i+(j*WIDTH))*2];
        
        *pix = i* 256;
       }
#else
   Do_Capture();   
#endif            
}






