

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
/*                                                          */
/*    Author:   Thomas Pantzer                              */
/*    Date:     Mon Feb 12 14:57:41 MEZ 1996                */
/*    File:     modules.cc                                  */
/*    Function:						    */	
/*             						    */
/*__________________________________________________________*/



#include "portnum.h"
#include "modules.h"
#include "messages.h"
#include "utils.h"

//globale Variablen aus eco_serv.cc
  extern struct Partner_Type Partner[MaxConnect]; 
  extern int Actual_Connected;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Kommunikation nur zwischen Server und Nutzer
//____________________________________________
void TellMe(int Msg,int self)
{
  unsigned int j,k;
  char str[256];

  switch(Msg) 
  {
    case HelpMsg: strcpy(str,_HELP_MSG); break;
    case UserMsg: if (Actual_Connected<=2)
                      sprintf(str,_OTHER_MSG,Actual_Connected);
                    else 
                      sprintf(str,_OTHER_MSG_2,Actual_Connected);

                  for (j=0;j<MaxConnect;j++)
                    if (Partner[j].connected==1)
                      if (j!=self)
                        sprintf(str,"%s %s",str,Partner[j].Name);
                        
                  sprintf(str,"%s\n",str);
                  break;
  }

  k=strlen(str);
  send(Partner[self].Socket,str,k,0);
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Kommunikation zu allen anderen Nutzern auer zum Nutzer selbst
// falls (msg==1) --> formatiere als wre es Meldung vom Server 
//______________________________________________________________ 
void TellOthers(char st[256],int self,int srvmsg)
{
  unsigned int i,j,k;
  char str[256];

  if (srvmsg==true)
      sprintf(str,"%s %s",Partner[self].Name,st);
    else
      sprintf(str,_PROMPT_STR,self,Partner[self].Name,st);
      
       
  printf("%s",str);
  k=strlen(str);

  for (j=0;j<MaxConnect;j++)
    if (Partner[j].connected==true)
      if (j!=self)
         {
          i=send(Partner[j].Socket,str,k,0);
          if (i==-1)
             {
              ErrorMsg("send()",errno);
              if (errno!=EIO)
                  {
                   shutdown(Partner[j].Socket,s_Full);
                   Actual_Connected--;
                   Partner[j].connected=false;
                   printf(_HASGONE_MSG,j,Actual_Connected);
                  }
             }
         } 
         
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//sagt allen anderen von welchem Host dieser Client "connected" hat
//_________________________________________________________________
void TellHostName(struct sockaddr_in *Client,int self)
{
  unsigned long int i,j;
  unsigned char k,l,m,n;
  char st[256],st2[256]; 
  struct hostent *remote;

  i=Client->sin_addr.s_addr / 65536;
  j=Client->sin_addr.s_addr % 65536;
  k=i / 256;
  l=i % 256;
  m=j / 256;
  n=j % 256;
  
  sprintf(st2,"%d.%d.%d.%d",n,m,l,k);
//  remote=gethostbyaddr((char *)&st,256,AF_INET); 
//  printf("remote:%s\tport:%s",remote->h_name,Client->sin_port);

  sprintf(st,_JOIN_MSG,st2);
  TellOthers(st,self,true);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// falls der Nutzer ein Backslash eingegeben hatte, wird ein Kommando interpretiert
// und ausgefhrt, falls das eingegebene Kommando noch nicht implementiert ist 
// wird auf die Standardausgabe des Servers geschrieben
//________________________________________________________________________________
void process_cmd(char st[256],int i)
{
  char st2[256],st3[256];

       if (strncmp(st,_EXIT_STR,5)==0)
            {
             shutdown(Partner[i].Socket,s_Full);
             Partner[i].connected=false;
             Actual_Connected--;
             TellOthers(_SIGNOFF_MSG,i,true);
            }
  else if (strncmp(st,_HELP_STR,5)==0)
            TellMe(HelpMsg,i);
  else if (strncmp(st,_USERS_STR,6)==0)
            TellMe(UserMsg,i);
  else if (sscanf(st,_MYNAME_STR,st3)>0)
            {
             sprintf(st2,_CHANGE_NAME_MSG,st3);
             TellOthers(st2,i,true);
             strcpy(Partner[i].Name,st3);
            } 
          else printf("==%s==",st);  
}



