/* 
 * Thomas Pantzer: capture.h, v0.1b  28.1.98 18:6 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */



#ifndef _CAPTURE_H
#define _CAPTURE_H

//#include "bttv.h"

#ifndef BTTV_DEV
#define BTTV_DEV "/dev/bttv"
#endif


#define DEFAULT_NORM 0
#define DEFAULT_STD 1
#define DEFAULT_SOURCE 1 

typedef struct { 
                 char name[32];
                 int id;
                 int width,height;
                 int pal_mode;
               } t_sizemode;  

typedef struct { 
        	int mode; 
                char *name; 
               } Gmode;

extern void SetBand(long int);
extern void SetSource(int);
extern void SetFreq(double d);
extern void SetCtrl(long c, double d);

extern int xcap_init(void);
extern void xcap_open(int bpp,char *host,int port);
extern void xcap_exit(void);
extern void xcap_resize(int );
extern void Do_Capture(void);

extern t_sizemode SizeMode[];
extern Gmode gmode[];


/*
unsigned char *GetImage(int left, int top, int right, int bottom);
void PutImage(int left, int top, unsigned char *bitmap, int op);

#define CopyPut 0
#define XORPut 1
#define OrPut  2
#define AndPut 3
#define NotPut 4
*/

#ifdef MAIN_G
#define vextern
#else
#define vextern extern
#endif


#define WIDTH 160
#define HEIGHT 120
#define BPP 1

#define PIC_SIZE (WIDTH*HEIGHT*BPP)

vextern int tvsock_fd;
vextern int vid_source;
vextern int vid_norm;
vextern int vid_std;
vextern unsigned char *vid_buffer;

vextern XImage *x_img;
// vextern bttv_window wtw;   
vextern int wtw_bpp;

vextern char dont_map_image;
vextern int win_initialized;
vextern XColor  xcol[256];
vextern Colormap cmap;
vextern double FPS;
vextern int Size;
vextern long int idle_cnt;
vextern int visual_mode;

#undef vextern

#endif
