/* 
 * Thomas Pantzer: capture.cc, v0.1b  23.4.98 14:36 
 * 
 * 
 * Copyright 1998 by Thomas Pantzer
 * 
 * Permission to use, copy, modify, and distribute this software for noncommercial 
 * use and without fee is hereby granted, provided that the above copyright notice 
 * appear in all copies and that both that copyright notice and this permission 
 * notice appear in supporting documentation, and that the name of the Author not be 
 * used in advertising or publicity pertaining to distribution of the software 
 * without specific, written prior permission. The Author makes no representations about
 * the suitability of this software for any purpose.  It is provided "as is" 
 * without expressed or implied warranty. 
 * 
 * 
 * pantec@aix520.informatik.uni-leipzig.de   (Thomas Pantzer) 
 * 
 */





//#include "bttv.h"
#include <stdio.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <fstream.h>
#include <string.h>

//#include <sys/socket.h>
//#include <X11/X.h>
//#include <X11/Xlib.h>

//#include <forms.h>

// #include "xcap.h"
#include "capture.h"
#include "ppmcompress.h"
#include "utils.h"
#include "netutils.h"

#include <netinet/in.h>



/*
t_sizemode SizeMode[] = {
                         {"160x120" , 1,160,120,1},
                         {"192x144" , 2,192,144,0},
                         {"240x180" , 3,240,180,1},
//                         {"288x216" , 4,288,216,0}, 
                         {"320x240" , 4,320,240,1},
                         {"360x288" , 5,360,288,0},
                         {"384x288" , 6,384,288,0},
//                         {"576x432" , 7,576,432,0}, 
                         {"640x480" , 8,640,480,1},
                         {"768x576" , 9,768,576,0},
                         {"16x9"    ,10,320,180,0}, 
                	 {"set mode", 0,768,576,0}
                        };

                         
#define VN(a) {a,#a}

Gmode gmode[] =
{
  VN(StaticGray), VN(GrayScale), VN(StaticColor),
  VN(PseudoColor), VN(TrueColor), VN(DirectColor),
};
*/

#ifdef DEBUG
#define CHECK_POINT(x,y)	fprintf(stderr,"%s: p%d\n",x,y)
#else
#define CHECK_POINT(x,y)	
#endif

/*
//void xcap_close(void)
//{
   CHECK_POINT("xcap_close",1);
   
   dont_map_image = true;

   fcntl(tvsock_fd,F_SETFL,O_NONBLOCK);
   shutdown(tvsock_fd,2);
      
   tvsock_fd = -1;   
//}
*/

void SetColorMap(void)
{
   CHECK_POINT("SetColorMap",1);

//   FL_COLOR cols[256];
       
//   for (int i=0; i<256; i++)
//     cols[i] = i;
         
//   fl_free_colors(cols,256);  

   int n = 16;
   for (int g=0; g<9; g++)
     {
      for (int r=0; r<5; r++)
        {
         for (int b=0; b<5; b++)
           {
            xcol[n].green = (255 * g)/8;  
            xcol[n].red   = (255 * r)/4;  
            xcol[n].blue  = (255 * b)/4;        
    
//            xcol[n].pixel = n;
//            xcol[n].flags = DoRed | DoGreen | DoBlue;

            n++;
           }
         }
      }
     
//    cmap = XCreateColormap(disp,win,
//                  DefaultVisual(disp,DefaultScreen(disp)),AllocAll);
    
#ifdef DEBUG   
//    fprintf(stderr,"display 0x%lx, win 0x%lx, cmap 0x%lx\n",(long)disp,(long)win,cmap);
#endif
//    XStoreColors(disp,cmap,xcol,256);
//    fl_set_canvas_colormap(fd_xcap->canvas,cmap);
//    fl_redraw_object(fd_xcap->canvas);    
}


void xcap_open(int bpp_mode,char *hostname_str,int portnum)
{
//   if (tvsock_fd > 0)
//      xcap_close();

   CHECK_POINT("xcap_open",1);   

  struct hostent *HostName; 
  struct servent *MyService;
  
  struct sockaddr_in ServerAddr;

//Hostangabe aus 1. Parameter oder Umgebungsvariable
  HostName = gethostbyname(hostname_str);
    
  if (HostName == (struct hostent *) 0)
      {
        char ST[256];
        sprintf(ST,"gethostbyname(%s)",hostname_str);
        ErrorMsg(ST,errno);
        exit(2);
      }
  
//  printf("h_addr %d\n",HostName->h_addr);

//Portnummer aus 2. Parameter, /etc/services  oder vor-
//definiert aus "portnum.h"
  
  ServerAddr.sin_port = htons(portnum);
  ServerAddr.sin_family = AF_INET;
  ServerAddr.sin_addr.s_addr = *(unsigned long int *)HostName->h_addr;
  
  tvsock_fd = socket(AF_INET,SOCK_STREAM,0);
  if (tvsock_fd == -1)
     {
      ErrorMsg("socket()",errno);
      exit(3);
     }
   
  if (connect(tvsock_fd,(struct sockaddr *)&ServerAddr,sizeof(ServerAddr))==-1)
     {
//     printf(_CONNECT_ERR_STR,errno);
      ErrorMsg("connect()",errno); 
      exit(4);
     }

   SetColorMap();

   CHECK_POINT("grab_on",1);

   dont_map_image = false;

   char msg[32];
   strcpy(msg,"get");
   write(tvsock_fd,&msg[0],strlen(msg)); 
}



int xcap_init(void)
{
   CHECK_POINT("xcap_init",1);

   tvsock_fd = -1;
   dont_map_image = true;
   
   JCS = init_jpeg(WIDTH,HEIGHT,3,75,10,JDCT_IFAST);

   return 3;
}



//typedef void (*sighandler_t)(int);
//sighandler_t signal(int signum, sighandler_t handler);


void xcap_exit(void)
{
   CHECK_POINT("xcap_exit",1);

   done_jpeg(JCS);
   
   CHECK_POINT("xcap_close",1);
   
   dont_map_image = true;

   ShutDown(tvsock_fd);
      
   tvsock_fd = -1;   
//   xcap_close();
   
   exit(0);
}



int error_cap = 0;
int RD = 0;
int SD = 0;
int block_flag = 0;
char resend_spawned = false;
unsigned char vbuf[(WIDTH*HEIGHT*BPP*2) + 5];
unsigned char lbuf[(WIDTH*3)+16];


char Do_Capture(void)
{

   if (
//       (dont_map_image == true) || 
//       (fd_xcap->xcap->visible == false) ||
       (tvsock_fd < 0) 
      )
      return false;

   CHECK_POINT("do_capture",1);

   int err;
   char msg[32];
   int rd,tr;
   JSAMPROW  row_pointer[1];
   int	  row_stride;

   row_stride = JCS->image_width * JCS->input_components;
   row_pointer[0]  = &lbuf[0];

      
   if (FD_Ready(tvsock_fd))
      {
       tr = PIC_SIZE - RD;
//       CHECK_POINT("data to get",tr);

/*
       if (tr == 0)
          {
           RD = 0;
           return true;
          }
 */   	

       rd = read(tvsock_fd,(char *)&vbuf[RD],tr);

       if (rd <= 0)
          {
           switch (errno)
             {
              case 11:  //EWOULDBLOCK
                block_flag++;   

                if (((block_flag > 8) && (resend_spawned == false)) || (block_flag > 64))
                   {
                    CHECK_POINT("would block resend",RD);
                 
                    sprintf(msg,"resend %d",RD);
                    write(tvsock_fd,&msg[0],strlen(msg)); 
                    block_flag = 0;
                    resend_spawned = true;
                   } 
                break;
      
              case 0:
              case 89:  // function not implemented  (conn.reset by peer on sun ??)
              case 131: // connection reset by peer
                xcap_exit();
                exit(1);
                break;
                        
              default:
                ErrorMsg("read_socket()",errno);
                
//                if ((RD == 0) || (idle_cnt > 23))
//                   {
//                    CHECK_POINT("..data",RD);
//                    CHECK_POINT("..idle_cnt",idle_cnt);
//                    strcpy(msg,"get");
//                    write(tvsock_fd,&msg[0],strlen(msg)); 
//                   } 
                break;
             }
              
           return false;
          } 
        else           
          {
           block_flag = 0;
           resend_spawned = false;
       
           
           if (strncmp((char *)&vbuf[RD],"start",5) == 0) 
              {
               int rs = rd - 5;
               
               for (int i=0; i<rs; i++)
                  vbuf[i] = vbuf[RD+5+i];
                  
               RD = rs;   
               
//               CHECK_POINT("sync read",rd);
              }
            else
              {
//               for (int i=0; i<rd; i++)
//                 buf[RD+i] = msg[i];
               
               RD += rd;  
//               CHECK_POINT("data read",rd);
//              } 

#define Line_Len (WIDTH*BPP)  
                  
//           if (RD >= (SD+Line_Len))   
//              {
               int lines = (RD - SD) / Line_Len;	
      
               if (lines > 0)
                  {         
                   for (int h=0; h<lines; h++)
                     {
                      for (int w=0; w<WIDTH; w++)
                        {
                         unsigned int i,j,k;
              
                         i = w + (h*WIDTH);
                         j = vbuf[SD+i];
                         k = w*3;
                
                         lbuf[k]   = xcol[j].red;
                         lbuf[k+1] = xcol[j].green;
                         lbuf[k+2] = xcol[j].blue;
                        }
             
                      jpeg_write_scanlines(JCS,row_pointer,1);
                     }
       
                   SD += (lines*Line_Len);
                  } 
              } 
          } 
       
       if (RD < PIC_SIZE)
          return false;
      } 
    else
      {
//       block_flag++;

//       if (((block_flag  > 8) && (resend_spawned == false)) || (block_flag > 64))
//          {
//           CHECK_POINT("not ready get sync",RD);
//           sprintf(msg,"sync");
//           write(tvsock_fd,&msg[0],strlen(msg)); 
//           block_flag = 0;
//           resend_spawned = true;
//          } 

       return false;   
      } 
   
   CHECK_POINT("got rest picture",SD);
   RD = 0;
//   SD = 0;

   
   int lines = (RD - SD) / Line_Len;
   int off = SD % Line_Len;   
      
   for (int h=0; h<lines; h++)
     {
           for (int w=0; w<WIDTH; w++)
             {
              unsigned int i,j,k;
  //            unsigned long r,g,b,l;
              
              i = w + ((h+off)*WIDTH);
              j = vbuf[i];
              k = w*3;
              
              lbuf[k]   = xcol[j].red;
              lbuf[k+1] = xcol[j].green;
              lbuf[k+2] = xcol[j].blue;
             }
             
        jpeg_write_scanlines(JCS,row_pointer,1);
     }             
   
   SD = 0;
   error_cap = 0;
//   pic_num++;

/*
   if ((pic_num % 64) == 0)
      {
       double d;
       d = (double)pic_num;

///       if (seconds > 0)
//          FPS = d / (double)seconds;
       
       pic_num = 0;
       seconds = 0;
//#ifdef DEBUG       
//       fprintf(stdout,"%3.1f frames per second\n",FPS);       
//#endif
      } 
 */
       
  strcpy(msg,"sync");
  int wr = write(tvsock_fd,&msg[0],strlen(msg)); 
  if (wr <= 0 )
     {
      xcap_exit();
     }
  
  return true;
}



// #define SEND(x)		{ char msg[32]; strcpy(msg,x); write(tvsock_fd,&msg[0],strlen(msg));}
